/* aes_enc_round.h */
/*
    This file is part of the AVR-Crypto-Lib.
    Copyright (C) 2010 Daniel Otte (daniel.otte@rub.de)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef AES_ENC_ROUND_H_
#define AES_ENC_ROUND_H_

typedef struct{
	uint8_t s[16];
} aes_cipher_state_t;

typedef struct{
	uint8_t ks[16];
} aes_roundkey_t;

void aes_enc_round(aes_cipher_state_t* state, const aes_roundkey_t* k);


#endif /* AES_ENC_ROUND_H_ */
